'DL165   Greenhouse Controller

'This is the source code for the uC/recv unit

$regfile = "2313def.dat"
$crystal = 7372800

Dim Synch As Byte
Dim Junk As Byte
Dim Ttop As Byte
Dim Tbot As Byte
Dim Tout As Byte
Dim Vents As Byte
Dim Ventsopen As Byte
Dim Ventshut As Byte
Dim Heateroffventshut As Byte
Dim Heater_on As Byte
Dim Heat As Byte
Dim Moisture As Byte
Dim Fan As Byte
Dim Battd10 As Byte
Dim Battr As Byte
Dim Message As Byte
Dim Tx As Byte

Dim N As Byte


Ddrb = &B11111111       'Portb pins are outputs
Config Portb = Output
 'B1(13) is DB4 to LCD
 'B2(14) is DB5 to LCD
 'B3(15) is DB6 to LCD
 'B4(16) is DB7 to LCD
 'B0(12) is E to LCD
 'D6(11) is RS to LCD

Ddrd = &B01011010
Portd.0 = 0
Portd.1 = 1       'TX for hardware UART
Portd.2 = 0
Portd.3 = 1       'D3(7) is output that turns the buzzer ON (EMERGENCY)
Portd.4 = 1       'D4(8) is output that flashes GREEN LED - GOOD DATA
Portd.5 = 0       'D5(9) is the recv DATA input to uC
Portd.6 = 1       'D6(11) is RS to LCD

Config Lcdpin = Pin , Db4 = Portb.1 , Db5 = Portb.2 , Db6 = Portb.3 , Db7 = Portb.4 , E = Portb.0 , Rs = 
Portd.6
Config Lcd = 20 * 4
Config Lcdmode = Port       'the report will show the settings
Config Lcdbus = 4       '4 bit mode
Cursor Off       'HIDE THE LCD CURSOR

Reset Portd.3       'START WITH BUZZER OFF "EMERGENCY"
Reset Portd.4       'START WITH GREEN LED OFF "Received Good Data"

'DL165   Greenhouse Controller

Message = 0

Start1:
Cls       'CLEAR THE LCD DISPLAY
Locate 1 , 1
Lcd "Synch=127 NOT REC'D"
Locate 2 , 1
Lcd "Synch=127 NOT REC'D"
Locate 3 , 1
Lcd "Synch=127 NOT REC'D"
Locate 4 , 1
Lcd "Synch=127 NOT REC'D"
Set Portd.3       'TURN ON THE BUZZER 50m second
Waitms 50
Reset Portd.3

Baud #2 , 1200
Start2:

Open "comd.5:1200,8,n,1,inverted" For Input As #2
Input #2 , Junk : Waitms 20       'was 20ms at 2400 baud
Input #2 , Synch
If Synch <> 127 Then Goto Start1
 Waitms 20
Input #2 , Ttop : Waitms 20
Input #2 , Tbot : Waitms 20
Input #2 , Tout : Waitms 20
Input #2 , Vents : Waitms 20       '0 = SHUT  255 = OPEN
Input #2 , Ventshut : Waitms 20
Input #2 , Ventsopen : Waitms 20
Input #2 , Heateroffventshut : Waitms 20
Input #2 , Heater_on : Waitms 20
Input #2 , Heat : Waitms 20
Input #2 , Moisture : Waitms 20
Input #2 , Fan : Waitms 20
Input #2 , Battd10 : Waitms 20
Input #2 , Battr : Waitms 20
Input #2 , Message : Waitms 20
Input #2 , Tx : Waitms 20
Close #2

Cls       'CLEAR THE LCD DISPLAY

If Message = 0 Then
 Set Portd.4       'Turn ON the green LED for 50ms "Received Good Data"
 Waitms 50       'Wait 50ms
 Reset Portd.4       'Turn OFF the green LED
End If

If Message = 255 Then
 Set Portd.3       'TURN ON THE BUZZER for 1 second
 Wait 1
 Reset Portd.3
 Set Portd.4       'Turn ON the green LED,will not turn OFF until Message=0                   '
'DL165   Greenhouse Controller

End If

Locate 1 , 1 : Lcd "TOP=" ; Ttop       'select line 1 and position 1
Locate 1 , 9 : Lcd "VENT" ; Ventshut ; "-" ; Ventsopen ; "="
If Vents = 0 Then
 Locate 1 , 20 : Lcd "S"
End If
If Vents = 255 Then
 Locate 1 , 20 : Lcd "O"
End If

Locate 2 , 1 : Lcd "BOT=" ; Tbot
Locate 2 , 9 : Lcd "M="
If Moisture = 0 Then
 Locate 2 , 11 : Lcd "H"       'select line 2 and position 12
End If
If Moisture = 255 Then
 Locate 2 , 11 : Lcd "L"
End If

Locate 2 , 14 : Lcd "FAN=";
If Fan = 0 Then
 Locate 2 , 18 : Lcd "OFF"       '
End If
If Fan = 255 Then
 Locate 2 , 18 : Lcd "ON"       '
End If

Locate 3 , 1 : Lcd "OUT=" ; Tout
Locate 3 , 12 : Lcd "BATT=" ; Battd10 ; "." ; Battr

Locate 4 , 1 : Lcd "HTR=" ; Heater_on ; "-" ; Heateroffventshut
Locate 4 , 12 : Lcd "HEAT="
If Heat = 0 Then
 Locate 4 , 17 : Lcd "OFF"
End If
If Heat = 255 Then
 Locate 4 , 17 : Lcd "ON"
End If
Locate 4 , 20 : Lcd Tx

Wait 1

Goto Start2
End
